from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from articles.models import Article
from django.contrib import messages
from lots.models import Lot
from infosachats.models import InfoAchat
from infosventes.models import InfoVente
import decimal
from fournisseurs.models import Fournisseur
from articlescommandeefactures.models import Articlescommandeefactures
from articlescommandee.models import ArticleCommandee
from datetime import date
# Create your views here.
@login_required(login_url="/login/")
def liste_lots(request):
	context = {}
	context['segment'] = 'lot'
	context['lots'] = Lot.objects.exclude(numero_lot = None).order_by('date_arrivage').reverse()
	context['articles'] = Article.objects.all().order_by('created_at').reverse()

	return render(request, 'liste-lot.html', context)

@login_required(login_url="/login/")
def liste_lots_d_article(request):
	context = {}
	if request.method == "POST":
		id_article = request.POST.get('id_article')

	article = Article.objects.get(id = id_article)
	context['lots'] = Lot.objects.filter(article = article).order_by('date_arrivage').reverse()
	context['article'] = article
	context['articles'] = Article.objects.all()
	context['now'] = date.today()

	return render(request, 'liste-lot-d-article.html', context)


@login_required(login_url="/login/")
def lots_par(request):
	context = {}
	if request.method == "POST":
		id_nom_article = request.POST.get('article')
		# id_nom_entrepot = request.POST.get('entrepot')

	# if id_nom_article and id_nom_entrepot :
	if id_nom_article :
		id_article =  id_nom_article.split()[0]
		article = Article.objects.get(id = id_article)
		# id_entrepot =  id_nom_entrepot.split()[0]
		# entrepot = Entrepot.objects.get(id =id_entrepot)
		context['lots'] = Lot.objects.filter(article = article)
	
	# else:
	# 	if id_nom_article:
	# 		id_article =  id_nom_article.split()[0]
	# 		print("id_article", id_article)
	# 		article = Article.objects.get(id = id_article)
	# 		context['lots'] = Lot.objects.filter(article = article)
		# if id_nom_entrepot:
		# 	id_entrepot =  id_nom_entrepot.split()[0]
		# 	entrepot = Entrepot.objects.get(id =id_entrepot )
	# 	# 	context['lots'] = Lot.objects.filter(entrepot = entrepot)
	# context['entrepots'] = Entrepot.objects.all().values().order_by('nom')
	context['articles'] = Article.objects.all().order_by('created_at').reverse()
	return render(request, 'liste-lot.html', context)


# # suivi-lots.html
# @login_required(login_url="/login/")
# def suivi_lots(request):
# 	context = {}
# 	if request.method == "POST":
# 		id_lots = request.POST.get('id_lots')

# 	article = Article.objects.get(id = id_article)
# 	context['lots'] = Lot.objects.filter(article = article).order_by('created_at')
# 	context['entrepots'] = Entrepot.objects.all().values().order_by('nom')
# 	context['article'] = article

# 	return render(request, 'liste-lot-d-article.html', context)

# suivi-lots.html
@login_required(login_url="/login/")
def ajouter_lots(request):
	context = {}
	if request.method == "POST":
		id_article = request.POST.get('id_article')

	context['article'] = Article.objects.get(id = id_article)
	context['fournisseur'] = Fournisseur.objects.all()

	return render(request, 'ajouter-lots.html', context)

@login_required(login_url="/login/")
def liste_d_entree(request):
	context = {}
	if request.method == "POST":
		id_lots = request.POST.get('id_lots')
	context['lot'] = Lot.objects.get(id = id_lots)
	return render(request, 'suivi-lots.html', context)


@login_required(login_url="/login/")
def liste_des_lots(request):
	context = {}
	if request.method == "POST":
		id_lots = request.POST.get('id_lots')

	context['lot'] = Lot.objects.get(id = id_lots)

	return render(request, 'suivi-lots.html', context)


@login_required(login_url="/login/")
def valider_lot(request):
	context = {}
	if request.method =="POST":
		quantitee = request.POST.get('quantitee')
		id_article = request.POST.get('id_article')
		ht_ttc_achat = request.POST.get('ht_ttc_achat')
		ht_ttc_vente = request.POST.get('ht_ttc_vente')
		date_arrivage = request.POST.get('date_arrivage')
		id_fournisseur = request.POST.get('fournisseur')

		upc = request.POST.get('upc')
		prix_vente = request.POST.get('prix_vente')
		taxe_vente = request.POST.get('taxe_vente')
		prix_de_revient = request.POST.get('prix_de_revient')
		taxe_achat = request.POST.get('taxe_achat')
		numero_lot = request.POST.get('numero_lot')
	
	article = Article.objects.get(id = id_article)
	if decimal.Decimal(quantitee) <= article.quantitee_non_declarer_comme_lot and decimal.Decimal(quantitee) > 0  :
		if Lot.objects.filter(numero_lot = numero_lot).exists():
			messages.error(request, "Numéro de lot dupliqué.  ")
		else:
				if id_fournisseur :
					fournisseur = Fournisseur.objects.get(id =id_fournisseur )
				else :
					fournisseur = None
				infosachat = InfoAchat(prix_de_revient = prix_de_revient, taxe = taxe_achat, ht_ttc_achat = ht_ttc_achat )
				infosvente = InfoVente(prix_vente = prix_vente ,taxe = taxe_vente, ht_ttc_vente = ht_ttc_vente )
				infosachat.save()
				infosvente.save()
				lot = Lot(article =article ,  fournisseur = fournisseur , infosachat = infosachat , infosvente = infosvente, quantitee = quantitee, quantitee_ouverture= quantitee ,date_arrivage = date_arrivage, numero_lot = numero_lot, upc = upc)
				lot.save()
				quantitee_non_declarer_comme_lot = article.quantitee_non_declarer_comme_lot
				Article.objects.filter(id=id_article).update(quantitee_non_declarer_comme_lot = quantitee_non_declarer_comme_lot-decimal.Decimal(quantitee))
				messages.success(request, "lot a été bien ajouté")
	else :
		messages.error(request, "la quantité doit etre inferieure ou egal à la quantité declarée")

	article = Article.objects.get(id = id_article)

	context['article'] = article
	return render(request, 'ajouter-lots.html', context)

@login_required(login_url="/login/")
def afficher_modifier_lot(request):
	context = {}

	if request.method =="POST":
		id_lot = request.POST.get('id_lot')
		lot = Lot.objects.get(id = id_lot)
		context['lot'] = lot
		context['article'] = Article.objects.get(id = lot.article.id)
		context['fournisseur'] = Fournisseur.objects.all()
		context['infovente'] = InfoVente.objects.get( id = lot.infosvente.id)
		context['infoachat'] = InfoAchat.objects.get( id = lot.infosachat.id)
	
	return render(request, 'modifier-lot.html', context)

@login_required(login_url="/login/")
def valider_modifier_lot(request):
	context = {}

	if request.method =="POST":
		id_lot = request.POST.get('lot')
		quantitee = request.POST.get('quantitee')
		id_infovente = request.POST.get('infovente')
		id_infoachat = request.POST.get('infoachat')
		ht_ttc_achat = request.POST.get('ht_ttc_achat')
		ht_ttc_vente = request.POST.get('ht_ttc_vente')
		date_arrivage = request.POST.get('date_arrivage')

		id_fournisseur = request.POST.get('fournisseur')
		print('id_fournisseur ' , id_fournisseur)
		if id_fournisseur != '':
			fournisseur = Fournisseur.objects.get(id =id_fournisseur )
		else : 
			fournisseur = None
		upc = request.POST.get('upc')
		prix_vente = request.POST.get('prix_vente')
		taxe_vente = request.POST.get('taxe_vente')
		prix_de_revient = request.POST.get('prix_de_revient')
		taxe_achat = request.POST.get('taxe_achat')
		numero_lot = request.POST.get('numero_lot')

		id_article = Lot.objects.get(id = id_lot).article.id
		Lot.objects.filter(id = id_lot).update(numero_lot = numero_lot)
		Lot.objects.filter(id = id_lot).update(upc = upc)
		
		if date_arrivage :
			Lot.objects.filter(id = id_lot).update(date_arrivage = date_arrivage)
		if id_fournisseur != '':
			Fournisseur.objects.filter(id = id_lot).update(fournisseur = fournisseur)	

		InfoAchat.objects.filter(id = id_infoachat).update(ht_ttc_achat = ht_ttc_achat)
		InfoAchat.objects.filter(id = id_infoachat).update(prix_de_revient = prix_de_revient)
		InfoAchat.objects.filter(id = id_infoachat).update(taxe = taxe_achat)

		InfoVente.objects.filter(id = id_infovente).update(ht_ttc_vente = ht_ttc_vente)
		InfoVente.objects.filter(id = id_infovente).update(prix_vente = prix_vente)
		InfoVente.objects.filter(id = id_infovente).update(taxe = taxe_vente)
		article = Article.objects.get(id = id_article)
		if decimal.Decimal(quantitee) < Lot.objects.get(id = id_lot).quantitee :
			dif = Lot.objects.get(id = id_lot).quantitee - decimal.Decimal(quantitee)
			new_qt_n_dec = article.quantitee_non_declarer_comme_lot + dif
		else :
			dif =  decimal.Decimal(quantitee) - Lot.objects.get(id = id_lot).quantitee 
			new_qt_n_dec = article.quantitee_non_declarer_comme_lot - dif
			
		Lot.objects.filter(id = id_lot).update(quantitee = quantitee)
		Article.objects.filter(id = id_article).update(quantitee_non_declarer_comme_lot = new_qt_n_dec)

		messages.success(request, "lot a été bien modifier")
	context['lots'] = Lot.objects.filter(article = article).order_by('date_arrivage').reverse()
	context['article'] = Article.objects.get(id = id_article)

	return render(request, 'liste-lot-d-article.html', context)

@login_required(login_url="/login/")
def Supprimer_lot(request):
	context = {}

	if request.method =="POST":
		id_lot = request.POST.get('id_lot')
		lot = Lot.objects.get(id = id_lot)
		if ArticleCommandee.objects.filter(lot = lot).exists() :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')
		else :	
			id_article = Lot.objects.get(id = id_lot).article.id
			article = Article.objects.get(id = id_article)
			new_qt_n_dec = article.quantitee_non_declarer_comme_lot + Lot.objects.get(id = id_lot).quantitee 
			Article.objects.filter(id = id_article).update(quantitee_non_declarer_comme_lot = new_qt_n_dec)
			messages.success(request, "lot a été bien Supprimer")
			lot.delete()

	context['lots'] = Lot.objects.filter(article = article).order_by('created_at')
	context['article'] = Article.objects.get(id = id_article)

	return render(request, 'liste-lot-d-article.html', context)


@login_required(login_url="/login/")
def detail_lot(request):
	context = {}
	id_lot = request.POST.get('lot')
	lot = Lot.objects.get(id = id_lot)

	context['InfoAchat'] = InfoAchat.objects.get(lot = lot)
	context['InfoVente'] = InfoVente.objects.get(lot = lot)
	context['lot'] = Lot.objects.get(id = id_lot)

	return render(request, 'detail-lot.html', context)